## libcxx-serial 1.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(serial)

# Find catkin
find_package(catkin REQUIRED)

if(APPLE)
	find_library(IOKIT_LIBRARY IOKit)
	find_library(FOUNDATION_LIBRARY Foundation)
endif()

if(UNIX AND NOT APPLE)
    # If Linux, add rt and pthread
    catkin_package(
        LIBRARIES ${PROJECT_NAME}
        INCLUDE_DIRS include
        DEPENDS rt pthread
    )
else()
    # Otherwise normal call
    catkin_package(
        LIBRARIES ${PROJECT_NAME}
        INCLUDE_DIRS include
    )
endif()

## Sources
set(serial_SRCS
    src/serial.cc
    include/serial/serial.h
    include/serial/v8stdint.h
)
if(APPLE)
	# If OSX
	list(APPEND serial_SRCS src/impl/unix.cc)
	list(APPEND serial_SRCS src/impl/list_ports/list_ports_osx.cc)
elseif(UNIX)
    # If unix
    list(APPEND serial_SRCS src/impl/unix.cc)
    list(APPEND serial_SRCS src/impl/list_ports/list_ports_linux.cc)
else()
    # If windows
    list(APPEND serial_SRCS src/impl/win.cc)
    list(APPEND serial_SRCS src/impl/list_ports/list_ports_win.cc)
endif()

## Add serial library
add_library(${PROJECT_NAME} ${serial_SRCS})
if(APPLE)
	target_link_libraries(${PROJECT_NAME} ${FOUNDATION_LIBRARY} ${IOKIT_LIBRARY})
elseif(UNIX)
	target_link_libraries(${PROJECT_NAME} rt pthread)
else()
	target_link_libraries(${PROJECT_NAME} setupapi)
endif()

## Uncomment for example
add_executable(serial_example examples/serial_example.cc)
add_dependencies(serial_example ${PROJECT_NAME})
target_link_libraries(serial_example ${PROJECT_NAME})

## Include headers
include_directories(include)

## Install executable
install(TARGETS ${PROJECT_NAME}
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

## Install headers
install(FILES include/serial/serial.h include/serial/v8stdint.h
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/serial)

## Tests
if(CATKIN_ENABLE_TESTING)
    add_subdirectory(tests)
endif()

=== Makefile ===
all: serial

CMAKE_FLAGS := -DCMAKE_INSTALL_PREFIX=/tmp/usr/local
UNAME := $(shell uname -s)

install_deps:
ifeq ($(UNAME),Darwin)
	brew tap ros/deps
	brew update
	brew outdated boost || brew upgrade boost || brew install boost
	sudo pip install rosinstall_generator wstool rosdep empy catkin_pkg
	sudo rosdep init
	rosdep update
	mkdir catkin_ws
	cd catkin_ws && rosinstall_generator catkin --rosdistro hydro --tar > catkin.rosinstall
	cd catkin_ws && wstool init src catkin.rosinstall
	cd catkin_ws && rosdep install --from-paths src --ignore-src -y
	cd catkin_ws && ./src/catkin/bin/catkin_make install
	echo "source catkin_ws/install/setup.bash" > setup.bash
else
	sudo sh -c 'echo "deb http://packages.ros.org/ros/ubuntu precise main" > /etc/apt/sources.list.d/ros-latest.list'
	wget http://packages.ros.org/ros.key -O - | sudo apt-key add -
	sudo apt-get update
	sudo apt-get install ros-hydro-catkin libboost-dev
	echo "source /opt/ros/hydro/setup.bash" > setup.bash
endif

install:
	cd build && make install

uninstall:
	cd build && make uninstall

serial:
	@mkdir -p build
	cd build && cmake $(CMAKE_FLAGS) ..
ifneq ($(MAKE),)
	cd build && $(MAKE)
else
	cd build && make
endif

.PHONY: clean
clean:
	rm -rf build

.PHONY: doc
doc:
	@doxygen doc/Doxyfile
ifeq ($(UNAME),Darwin)
	@open doc/html/index.html
endif

.PHONY: test
test:
	@mkdir -p build
	cd build && cmake $(CMAKE_FLAGS) ..
ifneq ($(MAKE),)
	cd build && $(MAKE) run_tests
else
	cd build && make run_tests
endif

=== tests/CMakeLists.txt ===
if(UNIX)
    catkin_add_gtest(${PROJECT_NAME}-test unix_serial_tests.cc)
    target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME} ${Boost_LIBRARIES})
    if(NOT APPLE)
        target_link_libraries(${PROJECT_NAME}-test util)
    endif()

    catkin_add_gtest(${PROJECT_NAME}-test-timer unit/unix_timer_tests.cc)
    target_link_libraries(${PROJECT_NAME}-test-timer ${PROJECT_NAME})
endif()

=== debian/changelog ===
libcxx-serial (1.2.1-8ubuntu1) questing; urgency=medium

  * Remove Build-Depends: catkin since it's not available in Ubuntu
    (LP: #2099760)
  * Update debian/rules to skip catkin build tests

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 23 Sep 2025 15:34:44 -0400

libcxx-serial (1.2.1-8) unstable; urgency=medium

  * Add patch updating Doxygen configuration
  * New fix for nocheck builds, update to buggy 1.2.1-6. Closes: #1070256

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 31 May 2024 12:55:49 +0200

libcxx-serial (1.2.1-7) unstable; urgency=medium

  * Use correct distro unstable instead of 1.2.1-6 erroneous trixie

 -- Alec Leamas <leamas.alec@gmail.com>  Sun, 12 May 2024 21:49:36 +0200

libcxx-serial (1.2.1-6) trixie; urgency=medium

  * Avoid crash when running with nocheck profile. Closes: #1070256
  * Update obsolete BD: pkg-config => pkgconf
  * Lintian is fixed, drop now obsolete  lintian-overrides false positive

 -- Alec Leamas <leamas.alec@gmail.com>  Sun, 12 May 2024 20:28:16 +0200

libcxx-serial (1.2.1-5) unstable; urgency=medium

  * Handle uninstalled cmake configuration files. Closes: #997732

 -- Alec Leamas <leamas.alec@gmail.com>  Sun, 24 Oct 2021 15:01:30 +0200

libcxx-serial (1.2.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Adopt to catkin installing pkgconfig to share (Closes: #977844)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 21 Dec 2020 20:38:16 +0100

libcxx-serial (1.2.1-4) unstable; urgency=medium

  * Add missing build-deps libgmock-dev and pkg-config. Closes: #973112

 -- Alec Leamas <leamas.alec@gmail.com>  Wed, 28 Oct 2020 18:33:57 +0100

libcxx-serial (1.2.1-3) unstable; urgency=medium

  * Fix FTBFS on i386. Kudos: Gianfranco Costamagna

 -- Alec Leamas <leamas.alec@gmail.com>  Wed, 23 Sep 2020 11:20:51 +0200

libcxx-serial (1.2.1-2) unstable; urgency=medium

  * Drop v8stdint.h header (not used in Debian). Closes: #921697
  * Update python-catkin-pkg BR to python3.
  * Standards-version -> 4.5.0, no changes.
  * Update dephelper-compat -> 12
  * Set Rules-Requires-Root
  * Add d/upstream/metadata
  * Handle DEB_BUILD_OPTIONS when overriding test target.
  * Clean up test target in d/rules,
  * Simplify d/rules using --buildsystem=cmake.
  * Reorganize repo branches according to dep-14.
  * Fix lingering templates in d/watch.
  * New local patches:
     - Drop v8stdint.h header (above)
  * Cherry-picked upstream bugfix patches:
     - Fix SerialImpl constructor resource leak.
     - Handle 500kpbs serial ports.
     - Plug memory leak in exceptions.
     - Use MONOTONIC clock.

 -- Alec Leamas <leamas.alec@gmail.com>  Sat, 19 Sep 2020 12:13:27 +0200

libcxx-serial (1.2.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop unused build dependency (Closes: #943082)

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 06 Nov 2019 21:21:43 +0100

libcxx-serial (1.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #917531)

 -- Alec Leamas <leamas.alec@gmail.com>  Thu, 27 Dec 2018 14:57:49 -0500

=== debian/control ===
Source: libcxx-serial
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alec Leamas <leamas.alec@gmail.com>
Build-Depends: debhelper-compat (= 13),
# catkin,
 cmake,
 doxygen,
 graphviz,
 libboost-dev,
 libgmock-dev,
 pkgconf
Standards-Version: 4.6.1
Section: libs
Homepage: http://wjwwood.io/serial/
Vcs-Browser: https://gitlab.com/leamas/cxx-serial
Vcs-Git: https://gitlab.com/leamas/cxx-serial.git
Rules-Requires-Root: no

Package: libcxx-serial-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcxx-serial1 (= ${binary:Version}), ${misc:Depends}
Description: Cross-platform, Serial Port library written in C++ (devel)
 A cross-platform library for interfacing with rs-232 serial like ports
 written in C++. It provides a modern C++ interface with a workflow
 designed to look and feel like PySerial, but with the speed and control
 provided by C++.
 .
 The upstream package name is serial. The Debian package is named
 cxx-serial to avoid a name conflict.
 .
 Serial is a class that provides the basic interface common to serial
 libraries (open, close, read, write, etc..) and requires no extra
 dependencies. It also provides tight control over timeouts and control
 over handshaking lines.
 .
 This package contains the development files (headers, unversioned
 so-librarie, pkg-config .pc file) and also some developer documentation.

Package: libcxx-serial1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cross-platform, Serial Port library written in C++ (runtime)
 A cross-platform library for interfacing with rs-232 serial like ports
 written in C++. It provides a modern C++ interface with a workflow
 designed to look and feel like PySerial, but with the speed and control
 provided by C++.
 .
 The upstream package name is serial. The Debian package is named
 cxx-serial to avoid a name conflict.
 .
 Serial is a class that provides the basic interface common to serial
 libraries (open, close, read, write, etc..) and requires no extra
 dependencies. It also provides tight control over timeouts and control
 over handshaking lines.
 .
 This package contains the runtime library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#	ENABLE_TESTS := ON
#else
#	ENABLE_TESTS := OFF
#endif

ENABLE_TESTS := OFF

%:
	echo foobar
	echo DEB_BUILD_PROFILES: $(DEB_BUILD_PROFILES)
	echo ENABLE_TESTS: $(ENABLE_TESTS)
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_VERBOSE_MAKEFILE=ON \
	    -DCATKIN_ENABLE_TESTING=$(ENABLE_TESTS)

#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	make -C obj-$(DEB_HOST_GNU_TYPE) \
#	    run_tests_cxx-serial_gtest_cxx-serial-test
#endif
